//+------------------------------------------------------------------+
//|                                                 HighLight_MS.mq4 |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 clrSilver
#property indicator_color2 clrSilver
#property indicator_color3 clrSilver
#property indicator_color4 clrSilver
extern int     = 10;
extern bool  = true;
extern int           z = 12;
extern color ColorS  = clrLightSalmon;
extern color ColorB  = clrYellowGreen;
extern int       Width = 6;
extern int  = 100;
extern bool  = true;
double ExtMapBuffer1[], ExtMapBuffer2[], ExtMapBuffer3[], ExtMapBuffer4[], zz;
int key;
//+------------------------------------------------------------------+
int init()  {
   SetIndexBuffer(0,ExtMapBuffer1);   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,Width,ColorS);
   SetIndexBuffer(1,ExtMapBuffer2);   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,Width,ColorS);
   SetIndexBuffer(2,ExtMapBuffer3);   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,Width,ColorB);
   SetIndexBuffer(3,ExtMapBuffer4);   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,Width,ColorB);
   return(0);
}
//+------------------------------------------------------------------+
int deinit()  {   return(0);  }
//+------------------------------------------------------------------+
int start()  {
   if(key==Time[0]) return(0);
   for(int i=; i>0; i--)  {
       ExtMapBuffer1[i] = 0;
       ExtMapBuffer2[i] = 0;
     if( FindMSH(i) )  {       // ingestion
       ExtMapBuffer1[i+1] = High[i+2];
       ExtMapBuffer2[i+1] = Close[i+1];
       ExtMapBuffer1[i+2] = High[i+2];
       ExtMapBuffer2[i+2] = Close[i+1];
       ExtMapBuffer1[i+3] = High[i+2];
       ExtMapBuffer2[i+3] = Close[i+1];
       if(i==0 && ) Alert(Symbol(),"   ",_Period,"     MSH-!");
     }
     if( FindMSL(i) )  {       // ingestion
       ExtMapBuffer3[i+1] = Low[i+2];
       ExtMapBuffer4[i+1] = Close[i+1];
       ExtMapBuffer3[i+2] = Low[i+2];
       ExtMapBuffer4[i+2] = Close[i+1];
       ExtMapBuffer3[i+3] = Low[i+2];
       ExtMapBuffer4[i+3] = Close[i+1];
       if(i==0 && ) Alert(Symbol(),"   ",_Period,"     MSL-!");
     }
   }
   key=Time[0];
   return(0);
}
//+------------------------------------------------------------------+
bool FindMSH(int k)  {
   double O1, C1, L1, L2, L3, H1, H2, H3, O3, C3;
  //+------------------------------------------------------------------+
      H1 = High[k+1];      H2 = High[k+2];     H3 = High[k+3];
      L1 = Low[k+1];       L2 = Low[k+2];      L3 = Low[k+3];
      C1 = Close[k+1];     C3 = Close[k+3]; 
      O1 = Open[k+1];      O3 = Open[k+3];   
//+------------------------------------------------------------------+
    // Check for a Market Structure High pattern
      if(O3<C3 && H3<H2 && H1<H2 && O1>C1 && C1<=L2)  {  //&& L3<L2
        if(High[iHighest(NULL,0,MODE_HIGH,,k+1)]==H2)  {
          if()  {
            zz=iCustom(NULL,0,"ZigZag",z,1,1,0,k+2);
            if(zz>0 && zz==H2) return(true);
          }
          else  return(true);
        }
      }
  return(0);
}
//+------------------------------------------------------------------+
bool FindMSL(int k)  {
   double O1, C1, L1, L2, L3, H1, H2, H3, O3, C3;
  //+------------------------------------------------------------------+
      H1 = High[k+1];      H2 = High[k+2];     H3 = High[k+3];
      L1 = Low[k+1];       L2 = Low[k+2];      L3 = Low[k+3];
      C1 = Close[k+1];     C3 = Close[k+3]; 
      O1 = Open[k+1];      O3 = Open[k+3];   
//+------------------------------------------------------------------+
     // Check for Market Structure Low pattern
      if(O3>C3 && L3>L2 && L1>L2 && O1<C1 && C1>=H2)   {   // && H2<H3 -    High  Close  
        if(Low[iLowest(NULL,0,MODE_LOW,,k+1)]>=L2)  {
          if()  {
            zz=iCustom(NULL,0,"ZigZag",z,1,1,0,k+2);
            if(zz>0 && zz==L2) return(true);
          }
          else  return(true);
        }  
      }
  return(0);
}
//+------------------------------------------------------------------+
